#include <gtk/gtk.h>
#include <glib/gi18n.h>
#include <glib/gprintf.h>

gchar *hellostr;

void window_destroy(GtkWidget *widget, gpointer data)
{
  gtk_main_quit ();
}

void button_clicked(GtkWidget *widget, gpointer data)
{
  g_printf ("%s\n", hellostr);
}

GtkWidget *helloworld_new()
{
  GtkWidget *window, *button;
  
  hellostr = g_locale_to_utf8 (_ ("Hello World"), -1, NULL, NULL, NULL);
    
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (window_destroy), NULL);
  
  button = gtk_button_new_with_label (hellostr);
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked), NULL);
  g_signal_connect_swapped (G_OBJECT (button), "clicked",
			    G_CALLBACK (window_destroy), G_OBJECT (window));
  gtk_container_add (GTK_CONTAINER (window), button);
  gtk_widget_show (button);
  
  return window;
}

int main(int argc, char *argv[])
{
  GtkWidget *helloworld;
  
  gtk_init (&argc, &argv);
  
  helloworld = helloworld_new();
  gtk_widget_show (helloworld);
  
  gtk_main ();
  
  return 0;
}
